
LoadRequiredAddon("Weapon_Repeater"); //needed since this is just an edit of that






//////////////////////////////////////////////
// Repeater									//
// Created by Jaydee						//
// Damage: 20/bullet						//
// Spread: 0.0025							//
//////////////////////////////////////////////

//Repeater Two
//um. this is The Resonte!. i have no idea what i am doing.
//changes: much more "heat", making much more spread. also faster firing.




//Repeater trail
datablock ParticleData(RepeaterTwoTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 100;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	//textureName		= "base/data/particles/dot";
	textureName		= "base/data/particles/corona2";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
	colors[0]	= "1 1 1 0.2";
	colors[1]	= "1 0.75 0.05 0.1";
	colors[2]	= "1 0.75 0.05 0.0";
	sizes[0]	= 0.35;
	sizes[1]	= 0.15;
	sizes[2]	= 0.0;
	times[0]	= 0.0;
	times[1]	= 0.5;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(RepeaterTwoTrailEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = RepeaterTwoTrailParticle;
};










datablock ProjectileData(RepeaterTwoProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 5;
   directDamageType    = $DamageType::Repeater;
   radiusDamageType    = $DamageType::Repeater;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 50;
   verticalImpulse	  = 50;
   explosion           = RepeaterExplosion;
   bounceExplosion     = "";
   particleEmitter     = RepeaterTwoTrailEmitter; //bulletTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 900; //MUST BE ABOVE 0 FOR IT TO BOUNCE!
   lifetime            = 1000;
   fadeDelay           = 1000;
   bounceElasticity    = 0.99;
   bounceFriction      = 0.01;
   isBallistic         = true;
   gravityMod = 0.0;

   //bounceAngle         = 170; //stick almost all the time //from the default bow
   //bounceAngle         = 90;

   //hasLight    = true;
   hasLight    = false; //too many lights!
   //lightRadius = 1.0;
   //lightColor  = "1 0.76 0.05";

   uiName = "Repeater Two Bullet";
};

//NOTE: if this doesn't work just find TableSalt's fancy 10 gun edits and look at bouncy gun //aaaa its download is doawngrgm









//////////
// item //
//////////
datablock ItemData(RepeaterTwoItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "Add-Ons/Weapon_Repeater/repeater.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Repeater T.";
	iconName = "Add-Ons/Weapon_Repeater/icon_Repeater";
	doColorShift = true;
	colorShiftColor = "1 0.75 0.05 1.000";

	 // Dynamic properties defined by the scripts
	image = RepeaterTwoImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(RepeaterTwoImage)
{
   // Basic Item properties
   shapeFile = "Add-Ons/Weapon_Repeater/repeater.dts";
   emap = true;

   isChargeWeapon = true; //yo man look at this //it's for bots so they hold it down

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = RepeaterTwoItem;
   ammo = " ";
   projectile = RepeaterTwoProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;
   colorShiftColor = RepeaterTwoItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.01;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateTransitionOnTriggerUp[1]     = "Cooldown";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.01;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= RepeaterFireEmitter;
	stateEmitterTime[2]				= 0.01;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= repeaterShotSound;
	stateEjectShell[2]       = true;
	
	//Nonexistant smoke
	stateName[3] = "Smoke";
	//stateEmitter[3]					= RepeaterSmokeEmitter;
	//stateEmitterTime[3]				= 0.01;
	//stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.01;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4]			= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]     = "Ready";
	stateTransitionOnTriggerDown[4]     = "Ready";
	stateSequence[4]	= "Ready";
	
	stateName[5] = "Cooldown";
	stateTimeoutValue[5]            = 0.01;
	stateTransitionOnTimeout[5]     = "Ready";
	stateScript[5]                  = "Cooldown";
};

function RepeaterTwoImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, "Fire");
		%obj.playThread(2, Plant);
		
	//New Code that applies dynamic spread depending on how much is your fire rate. 
	//Little ticks give you a more accurate shot, spraying gives the traditional spread.
	
	%projectile = %this.projectile;
	%spread = 0.00075 * (%obj.heat * 0.1);
	%shellcount = 7; //okay so this controls how many projectiles are fired at the same time? okay sure
	

	%obj.maxHeat = 1000;
	
	if(%obj.heat < %obj.maxHeat)
		%obj.heat += 250;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);
		//%scale = getWord(%player.getScale(), 2); //projectiles and movement are scaled with the player's Z axis size by default.

		%scaleFactor = getWord(%obj.getScale(), 2);
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
			//scale = getWord(client.getScale(), 2);
		};
		%p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
		MissionCleanup.add(%p);
	}
	return %p;
}

//Random impact sounds for lols
function RepeaterTwoProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal)
{
	Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
	%random = getRandom(1,3);
	switch(%random)
	{
		case 1:
			serverplay3d(impact1HitSound,%pos);
		case 2:
			serverplay3d(impact2HitSound,%pos);
		case 3:
			serverplay3d(impact3HitSound,%pos);
		default:
			echo("Error on Repeater");
	}
}

//Smooth cooldown intended
function RepeaterTwoImage::Cooldown(%this,%obj,%slot)
{
	if (%obj.heat > 0)
	{
	%obj.heat -= %obj.maxHeat*0.1;
	}
}